
<p>U prethodnoj lekciji upoznali smo se s koderima: to su bili standardni kombinacijski moduli koji su na ulazu omogućili korisniku da odabere jedan od simbola iz domene a na izlazu su generirali kodnu riječ kojom je taj simbol kodiran. Odabir željenog simbola korisnik je radio tako što je na ulaz kodera doveo kodnu riječ jednojediničnog koda: samo je na jednom ulaznom bitu smjela biti postavljena vrijednost 1.</p>

<p>Takav koder ima dva problema. Oba proizlaze iz situacije kada ulazni podatak nije riječ jednojediničnog koda.</p>

<ol class="mlSpread">
<li>Što učiniti ako su nule dovedene na sve ulaze? Drugim riječima, ako korisnik nije odabrao simbol čiju kodnu riječ želi dobiti na izlazima kodera.</li>
<li>Što učiniti ako je na ulaze dovedeno više jedinica? Drugim riječima, ako korisnik istovremeno odabere više simbola. Koder ima izlaz za samo jednu kodnu riječ pa na taj izlaz ne može istovremno postaviti kodne riječi za sve odabrane simbole.</li>
</ol>

<p>Prioritetni koder je modifikacija kodera koja rješava oba problema.</p>

<p>Prvi problem prioritetni koder rješava na način da koderu dodaje još jedan jednobitni izlaz: zastavicu <i>y</i>. Ako na ulazu kodera nije odabran niti jedan simbol, prioritetni koder će izlaz <i>y</i> postaviti na vrijednost 0 čime korisnika obavještava da kodnu riječ odnosno binarni uzorak koji se nalazi na njegovim izlazima <em>treba zanemariti</em> - izlaz nije valjan. Primjetite da će digitalni sklp i u tom slučaju nešto dati na izlazu: radi se o digitalnom sklopu i na tim izlazima će biti ili nule ili jedinice (odnosno neka njihova kombinacija); međutim, korisnik to naprosto treba zanemariti i ne tumačiti kao kod nekog simbola. Ako je na izlazima prioritetnog kodera valjana kodna riječ za odabrani simbol, tada će izlaz <i>y</i> biti postavljen na vrijednost 1.</p>

<p>Drugi problem prioritetni koder rješava na način da uvodi poredak među simbole domene. Primjerice, ako su simboli dekadske znamenke, poredak bi mogao biti na način da vrijednost znamenke definira i njezin prioritet. Tada, ako korisnik na ulazu odabere više simbola, odabranim simbolom se smatra onaj koji među odabranima ima najveći prioritet; kodna riječ koja je njemu dodijeljena bit će postavljena na izlaze prioritetnog kodera.</p>

<p>Interaktivna simulacija prioritetnog kodera za prirodni binarni kod za 8 cijelih brojeva (0 do 7) prikazana je u nastavku. Klikom miša možete podešavati koji su simboli odabrani. Provjerite što se događa ako niti jedan simbol nije odabran odnosno ako ih je više odabrano.</p>

<script>
@#page-include#(util.js)
@#page-include#(basic-coder.js)
@#page-include#(priority-coder.js)
@#page-include#(canvas.js)
</script>

<div style="text-align: center;">
<canvas id="myCanvas" width="170" height="420" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autori simulacije: Arijana Brlek, Nino Uzelac</span>
</div>

<script>
@#page-include#(priority-binary-coder.js)
  var binCdr = setupPriorityCoder("myCanvas", new PriorityBinaryCoder(3));
  binCdr.coder.draw(binCdr.canvas, binCdr.context);
</script>

<p>Interaktivna simulacija prioritetnog kodera koji obavlja kodiranje u skladu s Grayevim kodom prikazana je u nastavku. Isprobajte je. Koder kodira brojeve 0 do 7 u kodne riječi prema Grayevom kodu.</p>

<div style="text-align: center;">
<canvas id="myCanvas3" width="170" height="420" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autori simulacije: Arijana Brlek, Nino Uzelac</span>
</div>

<script>
@#page-include#(priority-gray-coder.js)
  var grayCdr = setupPriorityCoder("myCanvas3", new PriorityGrayCoder(3));
  grayCdr.coder.draw(grayCdr.canvas, grayCdr.context);
</script>

<p>Slijede dva primjera kodera za kodove koji služe za prikaz dekadskih znamenaka.</p>

<p>Interaktivna simulacija prioritetnog kodera koji obavlja kodiranje u skladu s BCD-kodom prikazana je u nastavku. Isprobajte je. Koder dekadskim znamenkama 0 do 9 pridjeljuje kodne riječi prema BCD-kodu.</p>

<div style="text-align: center;">
<canvas id="myCanvas2" width="170" height="420" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autori simulacije: Arijana Brlek, Nino Uzelac</span>
</div>

<script>
@#page-include#(priority-bcd-coder.js)
  var bcdCdr = setupPriorityCoder("myCanvas2", new PriorityBCDCoder());
  bcdCdr.coder.draw(bcdCdr.canvas, bcdCdr.context);
</script>

<p>Interaktivna simulacija prioritetnog kodera koji obavlja kodiranje u skladu s Excess-3-kodom prikazana je u nastavku. Isprobajte je. Koder dekadskim znamenkama 0 do 9 pridjeljuje kodne riječi prema Excess-3-kodu.</p>

<div style="text-align: center;">
<canvas id="myCanvas4" width="170" height="420" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autori simulacije: Arijana Brlek, Nino Uzelac</span>
</div>

<script>
@#page-include#(priority-excess3-coder.js)
  var ex3Cdr = setupPriorityCoder("myCanvas4", new PriorityExcess3Coder());
  ex3Cdr.coder.draw(ex3Cdr.canvas, ex3Cdr.context);
</script>

